// softuart-sendstring.c

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay_basic.h>


static unsigned char c , E_Reg;
static unsigned int m ;

static const char string[] PROGMEM =

"Laesst sich ein ATtiny13 in WinAVR trotz seines kleinen Flash-Speichers von 1kByte so \r\n\
programmieren, dass er mit einem PC ueber dessen serielle Schnittstelle kommunizieren kann, \r\r\
und zwar mit 9600 Baud? Dies ist moeglich, wie ich im Folgenden aufzeigen werde. Kürzlich \r\n\
entwarf ich naemlich in Anlehnung an Burkhard Kainkas Assembler-Unterprogramme zum Empfangen \r\n\
und Senden fuer den ATtiny13 auf der Platine des Lernpakets Mikrocontroller ein Programm in \r\n\
WinAVR, damit dieser Mikrocontroller ueber Pin PB1 senden und ueber PB2 empfangen kann.  \r\n\
";



void WrCOM(){
	PORTB |=(1<<PB1);    // TXD = 1
	_delay_loop_1(150);
	for (c=0;c<8;c++){
		if((E_Reg & 1)==0){
			PORTB |=(1<<PB1);    // TXD = 1   
		}
		else{
			PORTB &=~(1<<PB1);   // TXD = 0
		}
		_delay_loop_1(150);
		E_Reg=E_Reg>>1;
	}
	PORTB &=~(1<<PB1);   // TXD = 0
	_delay_loop_1(150);
}


void main(){

DDRB=0b00000010;  // PB1: Ausgang
PORTB=0b0001101;  // Pullups an ungenutzten Eingaengen

	while(1){

		for (m=0; m < sizeof (string); m++){
			E_Reg = pgm_read_byte (&string[m]);
			WrCOM();
		}
		for (m=0;m<32000;m++); //wait
	}
}
