// softuart-echo-final.c

#include <avr/io.h>
#include <util/delay.h>

unsigned char n,A_Reg,c,E_Reg;


void WrCOM(){
	PORTB |=(1<<PB1);    // TXD = 1
	_delay_us(204);
	for (c=0;c<8;c++){
		if((E_Reg & 1)==0){
			PORTB |=(1<<PB1);    // TXD = 1
		}
		else{
			PORTB &=~(1<<PB1);   // TXD = 0
		}
	_delay_us(190);
		E_Reg=E_Reg>>1;
	}
	PORTB &=~(1<<PB1);   // TXD = 0
	_delay_us(204);
}


void RdCOM(){
	while((PINB & 4)==0);
	_delay_us(310);
 	E_Reg=0;
	for(c=0;c<8;c++){
		E_Reg=E_Reg>>1;
		if((PINB & 4)==4){
			E_Reg=E_Reg|128;
		}
	_delay_us(190);  // <---- 70 zu lange 1 
	}
	_delay_us(204);
	E_Reg =~E_Reg;
}


void main(){

DDRB=0b00000010;  // PB1:Ausgang
PORTB=0b00011010;  // Pullups an ungenutzten Eingängen

//E_Reg = 85;
//WrCOM();

	while(1){
		RdCOM();
		WrCOM();
	}
}
