// softuart-sendchar.c

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>


static unsigned char c , E_Reg;

void WrCOM(){
	PORTB |=(1<<PB1);    // TXD = 1
	_delay_us(204);
	for (c=0;c<8;c++){
		if((E_Reg & 1)==0){
			PORTB |=(1<<PB1);    // TXD = 1   
		}
		else{
			PORTB &=~(1<<PB1);   // TXD = 0
		}
		_delay_us(190);
		E_Reg=E_Reg>>1;
	}
	PORTB &=~(1<<PB1);   // TXD = 0
	_delay_us(204);

}


void main(){

DDRB=0b00000010;  // PB1:Ausgang
PORTB=0b00001001;  // Pullups an ungenutzten Eingängen


	while(1){
		E_Reg = 85;
		WrCOM();
		_delay_ms(1);   //kleine Pause
	}
}
